///////////////////////////////////////////////////////////////////////////////
//////////////////////////  IBXTreeView - Demo ////////////////////////////////
///////////////////////////////////////////////////////////////////////////////
// Igor Ilyinsky 2001, www.sinn.ru/~mapnn (mapnn@sinn.ru) /////////////////////
///////////////////////////////////////////////////////////////////////////////

// if you have drag&drop support set property DragMode in IBXTreeView to dmAutomatic!

unit u_objects;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, DBTrees, IBDatabase, Db, IBSQL, ImgList, ExtCtrls,
  IBXtrees;

type
  TF_objects = class(TForm)
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    ImageList1: TImageList;
    Panel1: TPanel;
    B_CREATE: TButton;
    B_RENAME: TButton;
    B_DELETE: TButton;
    B_MOVE: TButton;
    IBXTreeView1: TIBXTreeView;
    procedure B_CREATEClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure B_RENAMEClick(Sender: TObject);
    procedure B_DELETEClick(Sender: TObject);
    procedure B_MOVEClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  F_objects: TF_objects;

implementation

uses u_objred;

{$R *.DFM}

procedure TF_objects.FormShow(Sender: TObject);
begin
 IBDatabase1.Params.Add('LC_CTYPE=WIN1251');    // !!! 
 IBDatabase1.DatabaseName:=extractfilepath(application.exename)+'base/demo.gdb';
 IBDatabase1.Connected:=TRUE;
 // INIT TREE
 IBXTreeView1.Database:=IBDatabase1;
 IBXTreeView1.Transaction:=IBTransaction1;
 IBXTreeView1.TableName:='OBJECTS';
 IBXTreeView1.Images:=ImageList1;
 // BUILD TREE
 IBXTreeView1.BuildTree('OBJECTS');
end;

procedure TF_objects.B_CREATEClick(Sender: TObject);    // INSERT NODE
begin
   application.createform(TF_objred,F_objred);
   try
     with F_objred do begin
          IBXTreeView2.Database:=IBDatabase1;
          IBXTreeView2.Transaction:=IBTransaction1;
          IBXTreeView2.TableName:=IBXTreeView1.Tablename;
          IBXTreeView2.Images:=IBXTreeView1.Images;
          IBXTreeView2.BuildTree(IBXTreeView1.Tablename);
          if ShowModal = mrOK then
             IBXTreeView1.InsertNode(IBXTreeView2.GetID(IBXTreeView2.Selected),Edit1.Text);
     end;
   finally
     F_objred.Free;
   end;
end;

procedure TF_objects.B_RENAMEClick(Sender: TObject);    // RENAME NODE
var InputString: string;
begin
  if not assigned(IBXTreeView1.Selected) then raise exception.create('Select Node!');
  InputString:=InputBox('Rename Node', 'Input new caption:',IBXTreeView1.Selected.Text);
  if InputString <> IBXTreeView1.Selected.Text then
  IBXTreeView1.RenameNode(IBXTreeView1.Selected,InputString);
end;

procedure TF_objects.B_MOVEClick(Sender: TObject);    // MOVE NODE
begin
   if not assigned(IBXTreeView1.Selected) then raise exception.create('Select Node!');
   application.createform(TF_objred,F_objred);
   try
     with F_objred do begin
          Caption:='Move Node';
          Label1.Caption:='Selected Node';
          Label2.Caption:='Select new Parent Node for selected Node';
          Edit1.ReadOnly:=true;
          Edit1.Text:=IBXTreeView1.Selected.Text;
          Button1.Caption:='Move';
          IBXTreeView2.Database:=IBDatabase1;
          IBXTreeView2.Transaction:=IBTransaction1;
          IBXTreeView2.TableName:=IBXTreeView1.Tablename;
          IBXTreeView2.Images:=IBXTreeView1.Images;
          IBXTreeView2.BuildTree(IBXTreeView1.Tablename);
          if ShowModal = mrOK then
             IBXTreeView1.MoveNode(IBXTreeView1.GetId(IBXTreeView1.Selected),
                                   IBXTreeView2.GetId(IBXTreeView2.Selected));
     end;
   finally
     F_objred.Free;
   end;
end;

procedure TF_objects.B_DELETEClick(Sender: TObject);  // DELETE NODE
begin
  if not assigned(IBXTreeView1.Selected) then raise exception.create('Select Node!');
  if messagedlg('Delete Node "'+IBXTreeView1.Selected.Text+'" ?',
                 mtConfirmation,[mbOk,mbCancel],0) = mrOK then
  IBXTreeView1.DeleteNode(IBXTreeView1.Selected);
end;

end.
